--- old/usr/src/uts/common/fs/zfs/dmu_tx.c	Wed Nov  6 12:52:06 2013
+++ new/usr/src/uts/common/fs/zfs/dmu_tx.c	Wed Nov  6 12:52:06 2013
@@ -635,9 +635,16 @@
 		uint64_t start = off >> shift;
 		uint64_t end = (off + len) >> shift;
 
-		ASSERT(dn->dn_datablkshift != 0);
 		ASSERT(dn->dn_indblkshift != 0);
 
+		/*
+		 * dnode_reallocate() can result in an object with indirect
+		 * blocks having an odd data block size.  In this case,
+		 * just check the single block.
+		 */
+		if (dn->dn_datablkshift == 0)
+			start = end = 0;
+
 		zio = zio_root(tx->tx_pool->dp_spa,
 		    NULL, NULL, ZIO_FLAG_CANFAIL);
 		for (uint64_t i = start; i <= end; i++) {
